import { DynamicModule, ModuleMetadata, Type } from '@nestjs/common';
import { AuthConfig } from './auth-config';
interface AuthConfigFactory {
    createMongoConfig(): Promise<AuthConfig> | AuthConfig;
}
export interface AuthAsyncConfig extends Pick<ModuleMetadata, 'imports'> {
    inject?: any[];
    useExisting?: Type<AuthConfigFactory>;
    useClass?: Type<AuthConfigFactory>;
    useFactory?: (...args: any[]) => Promise<AuthConfig> | AuthConfig;
}
export declare class AuthModule {
    static register(options: AuthConfig): DynamicModule;
    static registerAsync(options: AuthAsyncConfig): DynamicModule;
}
export {};
