/// <reference types="mongoose" />
import { JwtService } from '@nestjs/jwt';
import { UsersService } from '../users/users.service';
import { AuthCredentialsDto } from './dto/auth-credentials.dto';
export declare class AuthService {
    private readonly usersService;
    private readonly jwtService;
    constructor(usersService: UsersService, jwtService: JwtService);
    logIn(authCredentialsDto: AuthCredentialsDto): Promise<{
        accessToken: string;
    }>;
    validateUserPassword(authCredentialsDto: AuthCredentialsDto): Promise<string>;
    fetchUserData(userName: string): Promise<import("..").IUser & import("mongoose").Document<any, any, import("..").IUser>>;
}
