"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CompaniesModule = void 0;
const pagination_module_1 = require("./../pagination/pagination.module");
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const company_model_1 = require("../models-mongo/company.model");
const mongo_db_service_1 = require("../mongo-db/mongo-db.service");
const companies_controller_1 = require("./companies.controller");
const companies_service_1 = require("./companies.service");
let CompaniesModule = class CompaniesModule {
};
CompaniesModule = __decorate([
    (0, common_1.Module)({
        imports: [
            passport_1.PassportModule.register({ defaultStrategy: 'jwt' }),
            pagination_module_1.PaginationModule,
        ],
        controllers: [companies_controller_1.CompaniesController],
        providers: [
            companies_service_1.CompaniesService,
            {
                provide: 'MODEL',
                useFactory: (db) => db
                    .getConnection()
                    .model('Company', company_model_1.companySchema, 'companies'),
                inject: [mongo_db_service_1.MongoDbService],
            },
        ],
        exports: [companies_service_1.CompaniesService],
    })
], CompaniesModule);
exports.CompaniesModule = CompaniesModule;
//# sourceMappingURL=companies.module.js.map