import { PaginationService } from './../pagination/pagination.service';
import { PaginationDto } from './../pagination/pagination.dto';
import { Model } from 'mongoose';
import { ICompany } from '../models-mongo/company.model';
import { WebsocketGateway } from '../websocket/websocket.gateway';
import { CompanyDto } from './dto/company.dto';
export declare class CompaniesService {
    private readonly websocketService;
    private CompanyModel;
    private readonly paginationService;
    constructor(websocketService: WebsocketGateway, CompanyModel: Model<ICompany>, paginationService: PaginationService);
    fetchAllCompanies(query: any): Promise<ICompany[] | PaginationDto>;
    createCompany(newCompany: CompanyDto): Promise<ICompany>;
    updateCompany(nif: string, newCompany: CompanyDto): Promise<ICompany>;
    deleteCompany(nif: string): Promise<boolean>;
    findCompany(_id: string): Promise<ICompany>;
    findCompanyByNif(nif: string): Promise<ICompany>;
    notifyWebsockets(): Promise<void>;
}
