"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmailerController = void 0;
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const emailer_message_1 = require("./emailer-message");
const emailer_service_1 = require("./emailer.service");
let EmailerController = class EmailerController {
    constructor(emailerService) {
        this.emailerService = emailerService;
    }
    sendMail(email) {
        return this.emailerService.sendMail(email);
    }
};
__decorate([
    (0, common_1.Post)(),
    (0, swagger_1.ApiBody)({
        description: 'Sending a new email',
        examples: {
            example: {
                value: {
                    subject: "Subject text title",
                    receivers: [
                        "youremail@gmail.com",
                    ],
                    text: "This is a test email text",
                }
            }
        }
    }),
    (0, swagger_1.ApiOperation)({
        summary: 'Send an email. Not Authguard required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [emailer_message_1.Message]),
    __metadata("design:returntype", Promise)
], EmailerController.prototype, "sendMail", null);
EmailerController = __decorate([
    (0, common_1.Controller)('api/v1/emailer'),
    (0, swagger_1.ApiTags)('emailer'),
    __metadata("design:paramtypes", [emailer_service_1.EmailerService])
], EmailerController);
exports.EmailerController = EmailerController;
//# sourceMappingURL=emailer.controller.js.map