import { DynamicModule, ModuleMetadata, Type } from '@nestjs/common';
import { EmailerConfig } from './emailer-config';
interface EmailerConfigFactory {
    createEmailerConfig(): Promise<EmailerConfig> | EmailerConfig;
}
export interface EmailerAsyncConfig extends Pick<ModuleMetadata, 'imports'> {
    inject?: any[];
    useExisting?: Type<EmailerConfigFactory>;
    useClass?: Type<EmailerConfigFactory>;
    useFactory?: (...args: any[]) => Promise<EmailerConfig> | EmailerConfig;
}
export declare class EmailerModule {
    static register(options: EmailerConfig): DynamicModule;
    static registerAsync(options: EmailerAsyncConfig): DynamicModule;
    private static createConfigProviders;
}
export {};
