"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmailerService = void 0;
const common_1 = require("@nestjs/common");
let EmailerService = class EmailerService {
    constructor(options) {
        this.options = options;
    }
    async sendMail(data) {
        try {
            var nodemailer = require('nodemailer');
            var transporter = nodemailer.createTransport({
                service: this.options.service ? this.options.service : 'gmail',
                auth: {
                    user: this.options.sending_Email_Address,
                    pass: this.options.sending_Email_Password,
                },
                tls: {
                    rejectUnauthorized: false
                },
                secure: false,
            });
            const mailOptions = {
                from: this.options.sending_Email_Address,
                to: data.receivers,
                subject: data.subject,
                html: '<p>' + data.text + '</p>',
                attachments: data.attachments && data.attachments.length > 0 ? data.attachments : [],
            };
            let sendMailResult = false;
            await transporter.sendMail(mailOptions).then(function (info) {
                sendMailResult = true;
                console.log('MAILER - Email(s) alert(s) sent successfully.');
            }).catch(function (err) {
                sendMailResult = false;
                console.error(err);
            });
            return sendMailResult;
        }
        catch (err) {
            return false;
        }
    }
};
EmailerService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('CONFIG_OPTIONS')),
    __metadata("design:paramtypes", [Object])
], EmailerService);
exports.EmailerService = EmailerService;
//# sourceMappingURL=emailer.service.js.map