"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlobalConfigurationController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const swagger_1 = require("@nestjs/swagger");
const global_configuration_dto_1 = require("./dto/global-configuration.dto");
const global_configuration_service_1 = require("./global-configuration.service");
let GlobalConfigurationController = class GlobalConfigurationController {
    constructor(globalConfigurationService) {
        this.globalConfigurationService = globalConfigurationService;
    }
    async getGlobalConfiguration() {
        return await this.globalConfigurationService.getGlobalConfiguration();
    }
    async getValue(key) {
        return await this.globalConfigurationService.getValue(key);
    }
    async createGlobalConfig(newConfiguration) {
        return await this.globalConfigurationService.createGlobalConfig(newConfiguration);
    }
    async updateGlobalConfiguration(newConfiguration) {
        return await this.globalConfigurationService.updateGlobalConfiguration(newConfiguration);
    }
    async deleteGlobalConfig(key) {
        return await this.globalConfigurationService.deleteGlobalConfig(key);
    }
};
__decorate([
    (0, common_1.Get)(),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Get all global configuration. AuthGuard Required',
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], GlobalConfigurationController.prototype, "getGlobalConfiguration", null);
__decorate([
    (0, common_1.Get)('get-value/:key'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Get all global configuration. AuthGuard Required',
    }),
    __param(0, (0, common_1.Param)('key')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], GlobalConfigurationController.prototype, "getValue", null);
__decorate([
    (0, common_1.Post)(),
    (0, swagger_1.ApiBody)({
        description: 'Create a new global configuration',
        examples: {
            example: {
                value: {
                    key: "global_configuration",
                    value: "1",
                    description: 'Test global configuration value',
                    type: 'number',
                }
            }
        }
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiBody)({
        type: global_configuration_dto_1.GlobalConfigurationDto,
    }),
    (0, swagger_1.ApiOperation)({
        summary: 'Create new global configuration. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [global_configuration_dto_1.GlobalConfigurationDto]),
    __metadata("design:returntype", Promise)
], GlobalConfigurationController.prototype, "createGlobalConfig", null);
__decorate([
    (0, common_1.Put)(),
    (0, swagger_1.ApiBody)({
        description: 'Updating a existing global configuration',
        examples: {
            example: {
                value: {
                    key: "global_configuration",
                    value: "1",
                    description: 'Test global configuration value',
                    type: 'number',
                }
            }
        }
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiBody)({
        type: global_configuration_dto_1.GlobalConfigurationDto,
    }),
    (0, swagger_1.ApiOperation)({
        summary: 'Update global configuration. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array]),
    __metadata("design:returntype", Promise)
], GlobalConfigurationController.prototype, "updateGlobalConfiguration", null);
__decorate([
    (0, common_1.Delete)(':key'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Delete a global configuration. AuthGuard Required',
    }),
    __param(0, (0, common_1.Param)('key')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], GlobalConfigurationController.prototype, "deleteGlobalConfig", null);
GlobalConfigurationController = __decorate([
    (0, common_1.Controller)('api/v1/global-configuration'),
    (0, swagger_1.ApiTags)('global-configuration'),
    __metadata("design:paramtypes", [global_configuration_service_1.GlobalConfigurationService])
], GlobalConfigurationController);
exports.GlobalConfigurationController = GlobalConfigurationController;
//# sourceMappingURL=global-configuration.controller.js.map