"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MicroserviceConnectionService = void 0;
const common_1 = require("@nestjs/common");
const microservices_1 = require("@nestjs/microservices");
const microservice_connection_config_1 = require("./microservice-connection-config");
let MicroserviceConnectionService = class MicroserviceConnectionService {
    constructor(options) {
        this.options = options;
        this.client = microservices_1.ClientProxyFactory.create({
            transport: microservices_1.Transport.TCP,
            options: {
                host: this.options.host,
                port: this.options.port,
            },
        });
    }
    async onApplicationBootstrap() {
        this.getConnectionToBackend();
    }
    getClient() {
        this.client = microservices_1.ClientProxyFactory.create({
            transport: microservices_1.Transport.TCP,
            options: {
                host: this.options.host,
                port: this.options.port,
            },
        });
        return this.client;
    }
    async getConnectionToBackend() {
        try {
            await this.client.connect();
            console.log("CONEXION CORRECTA");
        }
        catch (error) {
            const errorText = error.message;
            if (errorText.includes('ECONNREFUSED')) {
                console.log('CONEXIÓN RECHAZADA POR EL BACKEND');
            }
            else if (errorText.includes('EADDRINUSE')) {
                console.log('EL PUERTO YA ESTÁ EN USO EN EL SISTEMA POR OTRO PROCESO');
            }
            else {
                console.log(errorText);
            }
        }
    }
};
MicroserviceConnectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('CONFIG_OPTIONS')),
    __metadata("design:paramtypes", [microservice_connection_config_1.MicroserviceConnectionConfig])
], MicroserviceConnectionService);
exports.MicroserviceConnectionService = MicroserviceConnectionService;
//# sourceMappingURL=microservice-connection.service.js.map