"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.companySchema = exports.contactSchema = void 0;
const mongoose_1 = require("mongoose");
exports.contactSchema = new mongoose_1.Schema({
    departament: { type: String, unique: false, required: true },
    name: { type: String, required: true },
    phone: { type: Number, required: true },
    email: { type: String, required: true },
});
exports.companySchema = new mongoose_1.Schema({
    name: {
        type: String,
        required: true,
    },
    nif: {
        type: String,
        unique: true,
        required: true,
        trim: true,
    },
    companyCode: {
        type: String,
        required: false,
        unique: true,
        lowercase: true,
        default: null,
    },
    contacts: {
        type: [exports.contactSchema],
        required: false,
        default: null,
    },
    extension: {
        type: mongoose_1.Schema.Types.Mixed,
        require: false,
    },
    active: {
        type: Boolean,
        required: false,
        default: false,
    },
    typeObj: { type: String, required: false, default: 'Company' },
}, {
    timestamps: true,
});
//# sourceMappingURL=company.model.js.map