import { DynamicModule, ModuleMetadata, Type } from '@nestjs/common';
import { MongoDbConfig } from './mongo-db-config';
interface MongoConfigFactory {
    createMongoConfig(): Promise<MongoDbConfig> | MongoDbConfig;
}
export interface MongoAsyncConfig extends Pick<ModuleMetadata, 'imports'> {
    inject?: any[];
    useExisting?: Type<MongoConfigFactory>;
    useClass?: Type<MongoConfigFactory>;
    useFactory?: (...args: any[]) => Promise<MongoDbConfig> | MongoDbConfig;
}
export declare class MongoDbModule {
    static register(options: MongoDbConfig): DynamicModule;
    static registerAsync(options: MongoAsyncConfig): DynamicModule;
    private static createConnectProviders;
}
export {};
