"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongoDbService = void 0;
const common_1 = require("@nestjs/common");
const mongoose = require("mongoose");
let MongoDbService = class MongoDbService {
    constructor(options) {
        this.options = options;
        if (this.options) {
            this.createConnectionDB(options);
        }
        else {
            console.error("[MongoDbService] No hay parametros de configuracion");
        }
    }
    async createConnectionDB(options) {
        try {
            let url = '';
            if (options.user && options.pass) {
                url = 'mongodb://' + options.user + ':' + options.pass + '@' + options.ip + ':' + options.port + '/' + options.database + '?authSource=admin';
            }
            else {
                url = 'mongodb://' + options.ip + ':' + options.port + '/' + options.database;
            }
            this.dbConnection = mongoose.createConnection(url, {
                useNewUrlParser: true,
                useFindAndModify: true,
                useUnifiedTopology: true,
                useCreateIndex: true,
                autoCreate: false,
                autoIndex: false
            });
            this.dbConnection.once('open', () => {
                console.log('Connected to ' + options.database);
            });
            this.dbConnection.on('error', () => {
                console.error('Error connecting to ' + options.database);
            });
        }
        catch (err) {
            return null;
        }
    }
    getConnection() {
        try {
            return this.dbConnection;
        }
        catch (err) {
            return null;
        }
    }
};
MongoDbService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('CONFIG_OPTIONS')),
    __metadata("design:paramtypes", [Object])
], MongoDbService);
exports.MongoDbService = MongoDbService;
//# sourceMappingURL=mongo-db.service.js.map