"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionsController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const permissions_service_1 = require("./permissions.service");
const permission_dto_1 = require("./dto/permission.dto");
const swagger_1 = require("@nestjs/swagger");
let PermissionsController = class PermissionsController {
    constructor(PermissionsService) {
        this.PermissionsService = PermissionsService;
    }
    fetchAllPermissions(query) {
        return this.PermissionsService.fetchAllPermissions(query);
    }
    createPermission(permission) {
        return this.PermissionsService.createPermission(permission);
    }
    updatePermission(name, permission) {
        return this.PermissionsService.updatePermission(name, permission);
    }
    deletePermission(name) {
        return this.PermissionsService.deletePermission(name);
    }
};
__decorate([
    (0, common_1.Get)(),
    (0, swagger_1.ApiQuery)({
        name: 'name',
        type: 'string',
        description: 'Name of permission to filter',
        required: false
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Get all permissions or filter by query params. Authguard required',
    }),
    __param(0, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], PermissionsController.prototype, "fetchAllPermissions", null);
__decorate([
    (0, common_1.Post)(),
    (0, swagger_1.ApiBody)({
        description: 'Creating a new permission',
        examples: {
            example: {
                value: {
                    name: "NEW_PERMISSION"
                }
            }
        }
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Create a new permission. Authguard required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [permission_dto_1.PermissionDto]),
    __metadata("design:returntype", Promise)
], PermissionsController.prototype, "createPermission", null);
__decorate([
    (0, common_1.Put)('/:name'),
    (0, swagger_1.ApiParam)({
        name: 'name',
        type: 'string',
        description: 'Name of permission to update'
    }),
    (0, swagger_1.ApiBody)({
        description: 'Updating a existing permission',
        examples: {
            example: {
                value: {
                    name: "UPDATE_PERMISSION"
                }
            }
        }
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Update a permission. Authguard required',
    }),
    __param(0, (0, common_1.Param)('name')),
    __param(1, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, permission_dto_1.PermissionDto]),
    __metadata("design:returntype", Promise)
], PermissionsController.prototype, "updatePermission", null);
__decorate([
    (0, common_1.Delete)('/:name'),
    (0, swagger_1.ApiParam)({
        name: 'name',
        type: 'string',
        description: 'Name of permission to delete.'
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Delete a permission. Authguard required',
    }),
    __param(0, (0, common_1.Param)('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], PermissionsController.prototype, "deletePermission", null);
PermissionsController = __decorate([
    (0, common_1.Controller)('api/v1/permissions'),
    (0, swagger_1.ApiTags)('permissions'),
    __metadata("design:paramtypes", [permissions_service_1.PermissionsService])
], PermissionsController);
exports.PermissionsController = PermissionsController;
//# sourceMappingURL=permissions.controller.js.map