"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionsModule = void 0;
const pagination_module_1 = require("./../pagination/pagination.module");
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const permission_model_1 = require("../models-mongo/permission.model");
const mongo_db_service_1 = require("../mongo-db/mongo-db.service");
const permissions_controller_1 = require("./permissions.controller");
const permissions_service_1 = require("./permissions.service");
let PermissionsModule = class PermissionsModule {
};
PermissionsModule = __decorate([
    (0, common_1.Module)({
        imports: [
            passport_1.PassportModule.register({ defaultStrategy: 'jwt' }),
            pagination_module_1.PaginationModule,
        ],
        controllers: [
            permissions_controller_1.PermissionsController
        ],
        providers: [
            permissions_service_1.PermissionsService,
            {
                provide: 'MODEL',
                useFactory: (db) => db.getConnection().model('Permission', permission_model_1.permissionSchema, 'permissions'),
                inject: [mongo_db_service_1.MongoDbService]
            }
        ],
        exports: [
            permissions_service_1.PermissionsService
        ]
    })
], PermissionsModule);
exports.PermissionsModule = PermissionsModule;
//# sourceMappingURL=permissions.module.js.map