import { PaginationService } from './../pagination/pagination.service';
import { Model } from 'mongoose';
import { IPermission } from '../models-mongo/permission.model';
import { PaginationDto } from '../pagination/pagination.dto';
import { WebsocketGateway } from '../websocket/websocket.gateway';
import { PermissionDto } from './dto/permission.dto';
export declare class PermissionsService {
    private readonly paginationService;
    private readonly websocketService;
    private PermissionModel;
    constructor(paginationService: PaginationService, websocketService: WebsocketGateway, PermissionModel: Model<IPermission>);
    fetchAllPermissions(query: any): Promise<IPermission[] | PaginationDto>;
    createPermission(permission: PermissionDto): Promise<IPermission>;
    updatePermission(name: string, permission: PermissionDto): Promise<IPermission>;
    deletePermission(name: string): Promise<boolean>;
    fetchPermission(name: string): Promise<IPermission & import("mongoose").Document<any, any, IPermission>>;
    notifyWebsockets(): Promise<any>;
}
