import { PaginationService } from './../pagination/pagination.service';
import { Model } from 'mongoose';
import { IRole } from '../models-mongo/role.model';
import { PermissionsService } from '../permissions/permissions.service';
import { UsersService } from '../users/users.service';
import { WebsocketGateway } from '../websocket/websocket.gateway';
import { RoleDto } from './dto/role.dto';
import { PaginationDto } from '../pagination/pagination.dto';
export declare class RolesService {
    private readonly paginationService;
    private readonly permissionService;
    private readonly usersService;
    private readonly websocketService;
    private RoleModel;
    constructor(paginationService: PaginationService, permissionService: PermissionsService, usersService: UsersService, websocketService: WebsocketGateway, RoleModel: Model<IRole>);
    fetchAllRoles(query: any): Promise<IRole[] | PaginationDto>;
    createRole(role: RoleDto): Promise<IRole>;
    updateRole(oldRoleName: string, newRole: RoleDto): Promise<IRole>;
    deleteRole(roleName: string): Promise<boolean>;
    findRole(role: string): Promise<IRole>;
    fetchRole(role: string): Promise<IRole>;
    notifyWebsockets(): Promise<void>;
}
