"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SftpController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const swagger_1 = require("@nestjs/swagger");
const sftp_request_dto_1 = require("./dto/sftp-request.dto");
const sftp_service_1 = require("./sftp.service");
let SftpController = class SftpController {
    constructor(sftpService) {
        this.sftpService = sftpService;
    }
    putFile(sftpRequest) {
        return this.sftpService.putFile(sftpRequest);
    }
    getFile(sftpRequest) {
        return this.sftpService.getFile(sftpRequest);
    }
    moveFile(sftpRequest) {
        return this.sftpService.moveFile(sftpRequest);
    }
    deleteFile(sftpRequest) {
        return this.sftpService.deleteFile(sftpRequest);
    }
    renameFile(sftpRequest) {
        return this.sftpService.renameFile(sftpRequest);
    }
    existsFile(sftpRequest) {
        return this.sftpService.existsFile(sftpRequest);
    }
    list(sftpRequest) {
        console.log("list");
        return this.sftpService.list(sftpRequest);
    }
    getBase64FromRemoteFile(sftpRequest) {
        return this.sftpService.getBase64FromRemoteFile(sftpRequest);
    }
    getBufferFromRemoteFile(sftpRequest) {
        return this.sftpService.getBufferFromRemoteFile(sftpRequest);
    }
    checkIfFileIsDirectory(sftpRequest) {
        return this.sftpService.checkIfFileIsDirectory(sftpRequest);
    }
    createFolder(sftpRequest) {
        return this.sftpService.createFolder(sftpRequest);
    }
    deleteFolder(sftpRequest) {
        return this.sftpService.deleteFolder(sftpRequest);
    }
};
__decorate([
    (0, common_1.Post)('putFile'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Put file in sftp server. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "putFile", null);
__decorate([
    (0, common_1.Post)('getFile'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Get file of sftp server. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "getFile", null);
__decorate([
    (0, common_1.Post)('moveFile'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Move file of sftp server. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "moveFile", null);
__decorate([
    (0, common_1.Post)('deleteFile'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Delete file of sftp server. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "deleteFile", null);
__decorate([
    (0, common_1.Post)('renameFile'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Rename a file of sftp server. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "renameFile", null);
__decorate([
    (0, common_1.Post)('existsFile'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Exist file in sftp server. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "existsFile", null);
__decorate([
    (0, common_1.Post)('list'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'List files in a sftp server route. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "list", null);
__decorate([
    (0, common_1.Post)('getBase64FromRemoteFile'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Get base64 from remote file. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "getBase64FromRemoteFile", null);
__decorate([
    (0, common_1.Post)('getBufferFromRemoteFile'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Get read stream from remote file. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "getBufferFromRemoteFile", null);
__decorate([
    (0, common_1.Post)('checkIfFileIsDirectory'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Check if file is directory. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "checkIfFileIsDirectory", null);
__decorate([
    (0, common_1.Post)('createFolder'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Create a folder in a sftp server. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "createFolder", null);
__decorate([
    (0, common_1.Post)('deleteFolder'),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Delete a folder in a sftp server. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [sftp_request_dto_1.SftpRequestDto]),
    __metadata("design:returntype", Promise)
], SftpController.prototype, "deleteFolder", null);
SftpController = __decorate([
    (0, common_1.Controller)(`api/v1/sftp`),
    (0, swagger_1.ApiTags)('sftp'),
    __metadata("design:paramtypes", [sftp_service_1.SftpService])
], SftpController);
exports.SftpController = SftpController;
//# sourceMappingURL=sftp.controller.js.map