import { DynamicModule, ModuleMetadata, Type } from "@nestjs/common";
import { SftpConfig } from "./sftp-config";
interface SftpConfigFactory {
    createSftpConfig(): Promise<SftpConfig> | SftpConfig;
}
export interface SftpAsyncConfig extends Pick<ModuleMetadata, 'imports'> {
    inject?: any[];
    useExisting?: Type<SftpConfigFactory>;
    useClass?: Type<SftpConfigFactory>;
    useFactory?: (...args: any[]) => Promise<SftpConfig> | SftpConfig;
}
export declare class SftpModule {
    static register(options: SftpConfig): DynamicModule;
    static registerAsync(options: SftpAsyncConfig): DynamicModule;
    private static createConfigProviders;
}
export {};
