"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var SftpModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.SftpModule = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const sftp_service_1 = require("./sftp.service");
let SftpModule = SftpModule_1 = class SftpModule {
    static register(options) {
        return {
            module: SftpModule_1,
            imports: [
                passport_1.PassportModule.register({ defaultStrategy: 'jwt' }),
            ],
            controllers: [],
            providers: [
                {
                    provide: 'CONFIG_OPTIONS',
                    useValue: options,
                },
                sftp_service_1.SftpService,
            ],
            exports: [sftp_service_1.SftpService],
        };
    }
    static registerAsync(options) {
        return {
            module: SftpModule_1,
            imports: [
                passport_1.PassportModule.register({ defaultStrategy: 'jwt' }),
            ],
            controllers: [],
            providers: [
                sftp_service_1.SftpService,
                ...this.createConfigProviders(options),
            ],
            exports: [sftp_service_1.SftpService],
            global: true
        };
    }
    static createConfigProviders(options) {
        if (options.useFactory) {
            return [
                {
                    provide: 'CONFIG_OPTIONS',
                    useFactory: options.useFactory,
                    inject: options.inject || [],
                }
            ];
        }
        return [
            {
                provide: 'CONFIG_OPTIONS',
                useFactory: async (optionsFactory) => await optionsFactory.createSftpConfig(),
                inject: [options.useExisting || options.useClass],
            }
        ];
    }
};
SftpModule = SftpModule_1 = __decorate([
    (0, common_1.Module)({})
], SftpModule);
exports.SftpModule = SftpModule;
//# sourceMappingURL=sftp.module.js.map