import { SftpRequestDto } from './dto/sftp-request.dto';
import { SftpConfig } from './sftp-config';
export declare class SftpService {
    private options;
    private Client;
    private sftp;
    private configurationSftp;
    constructor(options: SftpConfig);
    getSftpConfig(): Promise<SftpConfig>;
    setSftpConfig(options: SftpConfig): Promise<void>;
    putFile(sftpRequest: SftpRequestDto): Promise<boolean>;
    getFile(sftpRequest: SftpRequestDto): Promise<boolean>;
    moveFile(sftpRequest: SftpRequestDto): Promise<boolean>;
    deleteFile(sftpRequest: SftpRequestDto): Promise<boolean>;
    renameFile(sftpRequest: SftpRequestDto): Promise<boolean>;
    existsFile(sftpRequest: SftpRequestDto): Promise<boolean>;
    list(sftpRequest: SftpRequestDto): Promise<any[]>;
    getBase64FromRemoteFile(sftpRequest: SftpRequestDto): Promise<string>;
    getBufferFromRemoteFile(sftpRequest: SftpRequestDto): Promise<number[]>;
    checkIfFileIsDirectory(sftpRequest: SftpRequestDto): Promise<boolean>;
    uploadDir(sftpRequest: SftpRequestDto): Promise<boolean>;
    downloadDir(sftpRequest: SftpRequestDto): Promise<boolean>;
    createFolder(sftpRequest: SftpRequestDto): Promise<boolean>;
    deleteFolder(sftpRequest: SftpRequestDto): Promise<boolean>;
    closeConnection(): Promise<void>;
}
