import { SlackConfig } from './slack-config';
import { DynamicModule, ModuleMetadata, Type } from '@nestjs/common';
interface SlackConfigFactory {
    createSlackConfig(): Promise<SlackConfig> | SlackConfig;
}
export interface SlackAsyncConfig extends Pick<ModuleMetadata, 'imports'> {
    inject?: any[];
    useExisting?: Type<SlackConfigFactory>;
    useClass?: Type<SlackConfigFactory>;
    useFactory?: (...args: any[]) => Promise<SlackConfig> | SlackConfig;
}
export declare class SlackModule {
    static register(options: SlackConfig): DynamicModule;
    static registerAsync(options: SlackAsyncConfig): DynamicModule;
    private static createConfigProviders;
}
export {};
