"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var SlackService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.SlackService = void 0;
const common_1 = require("@nestjs/common");
let SlackService = SlackService_1 = class SlackService {
    constructor(options) {
        this.options = options;
        SlackService_1.appChannel = this.options.appChannel;
    }
    async createBot() {
        var SlackBot = require('slackbots');
        var bot = new SlackBot({
            token: this.options.token,
            name: this.options.name
        });
        return bot;
    }
    async checkType(type) {
        if (type != 'success' && type != 'info' && type != "warning" && type != "error") {
            return "error";
        }
        return type;
    }
    async getTypeIcon(type) {
        if (type == "success") {
            return ':large_green_circle:';
        }
        else if (type == "info") {
            return ':large_blue_circle:';
        }
        else if (type == "warning") {
            return ':large_yellow_circle:';
        }
        else if (type == "error") {
            return ':red_circle:';
        }
        else {
            return '';
        }
    }
    async formatText(textIcon, text) {
        const textMsg = `${textIcon} | ${text}`;
        return textMsg;
    }
    async messageToChannel(channel, text, type = "error") {
        try {
            const bot = await this.createBot();
            const params = {
                icon_emoji: ':robot_face:'
            };
            const validateType = await this.checkType(type);
            const textIcon = await this.getTypeIcon(validateType);
            const textMsg = await this.formatText(textIcon, text);
            await bot.on('start', async function () {
                await bot.postMessageToChannel(channel, textMsg, params);
            });
        }
        catch (error) {
        }
    }
    async messageToUser(user, text, type) {
        try {
            const bot = await this.createBot();
            const params = {
                icon_emoji: ':robot_face:'
            };
            const validateType = await this.checkType(type);
            const textIcon = await this.getTypeIcon(validateType);
            const textMsg = await this.formatText(textIcon, text);
            await bot.on('start', async function () {
                await bot.postMessageToChannel(user, textMsg, params);
            });
        }
        catch (error) {
        }
    }
    async messageOtherSlackBot(user, text, type) {
        try {
            const bot = await this.createBot();
            const params = {
                'slackbot': true,
                icon_emoji: ':robot_face:'
            };
            const validateType = await this.checkType(type);
            const textIcon = await this.getTypeIcon(validateType);
            const textMsg = await this.formatText(textIcon, text);
            await bot.on('start', async function () {
                await bot.postMessageToUser(user, textMsg, params);
            });
        }
        catch (error) {
        }
    }
    async messagePrivateGroup(channel, text, type) {
        try {
            const bot = await this.createBot();
            const params = {
                icon_emoji: ':robot_face:'
            };
            const validateType = await this.checkType(type);
            const textIcon = await this.getTypeIcon(validateType);
            const textMsg = await this.formatText(textIcon, text);
            await bot.on('start', async function () {
                await bot.postMessageToGroup(channel, textMsg, params);
            });
        }
        catch (error) {
        }
    }
};
SlackService = SlackService_1 = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('CONFIG_OPTIONS')),
    __metadata("design:paramtypes", [Object])
], SlackService);
exports.SlackService = SlackService;
//# sourceMappingURL=slack.service.js.map