import { DynamicModule, ModuleMetadata, Type } from '@nestjs/common';
import { TelegramConfig } from './telegram-config';
interface TelegramFactory {
    createTelegram(): Promise<TelegramConfig> | TelegramConfig;
}
export interface TelegramAsyncConfig extends Pick<ModuleMetadata, 'imports'> {
    inject?: any[];
    useExisting?: Type<TelegramFactory>;
    useClass?: Type<TelegramFactory>;
    useFactory?: (...args: any[]) => Promise<TelegramConfig> | TelegramConfig;
}
export declare class TelegramBotModule {
    static register(options: TelegramConfig): DynamicModule;
    static registerAsync(options: TelegramAsyncConfig): DynamicModule;
    private static createConnectProviders;
}
export {};
