"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var TelegramBotModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TelegramBotModule = void 0;
const common_1 = require("@nestjs/common");
const nestjs_telegram_1 = require("nestjs-telegram");
const telegram_bot_service_1 = require("./telegram-bot.service");
let TelegramBotModule = TelegramBotModule_1 = class TelegramBotModule {
    static register(options) {
        const dynamicModule = {
            module: TelegramBotModule_1,
        };
        dynamicModule.imports = [
            nestjs_telegram_1.TelegramModule.forRoot({
                botKey: options.botKey
            })
        ],
            dynamicModule.controllers = [];
        dynamicModule.providers = [telegram_bot_service_1.TelegramBotService];
        dynamicModule.exports = [telegram_bot_service_1.TelegramBotService];
        dynamicModule.global = true;
        return dynamicModule;
    }
    static registerAsync(options) {
        return {
            module: TelegramBotModule_1,
            imports: [
                nestjs_telegram_1.TelegramModule.forRootAsync({
                    useFactory: options.useFactory,
                    inject: options.inject || [],
                })
            ],
            providers: [
                telegram_bot_service_1.TelegramBotService,
                ...this.createConnectProviders(options)
            ],
            exports: [telegram_bot_service_1.TelegramBotService],
            global: true
        };
    }
    static createConnectProviders(options) {
        if (options.useFactory) {
            return [
                {
                    provide: 'TELEGRAM_MODULE_OPTIONS',
                    useFactory: options.useFactory,
                    inject: options.inject || [],
                }
            ];
        }
        return [
            {
                provide: 'TELEGRAM_MODULE_OPTIONS',
                useFactory: async (optionsFactory) => await optionsFactory.createTelegram(),
                inject: [options.useExisting || options.useClass],
            }
        ];
    }
};
TelegramBotModule = TelegramBotModule_1 = __decorate([
    (0, common_1.Module)({
        imports: [],
        controllers: [],
        providers: [],
        exports: [],
    })
], TelegramBotModule);
exports.TelegramBotModule = TelegramBotModule;
//# sourceMappingURL=telegram-bot.module.js.map