import { IUser } from '../models-mongo/user.model';
import { PaginationDto } from '../pagination/pagination.dto';
import { EditUserDto } from './dto/edit-user.dto';
import { UserDto } from './dto/user.dto';
import { UsersService } from './users.service';
export declare class UsersController {
    private usersService;
    constructor(usersService: UsersService);
    fetchAllUsers(query: any): Promise<IUser[] | PaginationDto>;
    createUser(newUser: UserDto): Promise<IUser>;
    createUserNoAuth(newUser: UserDto): Promise<IUser>;
    updateUser(userName: string, user: EditUserDto): Promise<IUser>;
    deleteUser(userName: string): Promise<IUser>;
    activateUser(userName: string): Promise<IUser>;
    pwdRecovery(email: string): Promise<IUser>;
    updateUserPassword(userName: string, user: EditUserDto): Promise<IUser>;
    fetchUserByPwdRecovery(pwdRecoveryToken: string): Promise<IUser>;
}
