"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsersController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const swagger_1 = require("@nestjs/swagger");
const edit_user_dto_1 = require("./dto/edit-user.dto");
const user_dto_1 = require("./dto/user.dto");
const users_service_1 = require("./users.service");
let UsersController = class UsersController {
    constructor(usersService) {
        this.usersService = usersService;
    }
    fetchAllUsers(query) {
        return this.usersService.fetchAllUsers(query);
    }
    createUser(newUser) {
        return this.usersService.createUser(newUser);
    }
    createUserNoAuth(newUser) {
        return this.usersService.createUser(newUser);
    }
    updateUser(userName, user) {
        return this.usersService.updateUser(userName, user);
    }
    deleteUser(userName) {
        return this.usersService.deleteUser(userName);
    }
    activateUser(userName) {
        return this.usersService.activateUser(userName);
    }
    pwdRecovery(email) {
        return this.usersService.pwdRecovery(email);
    }
    updateUserPassword(userName, user) {
        return this.usersService.updateUserPassword(userName, user);
    }
    fetchUserByPwdRecovery(pwdRecoveryToken) {
        return this.usersService.fetchUserByPwdRecovery(pwdRecoveryToken);
    }
};
__decorate([
    (0, common_1.Get)(),
    (0, swagger_1.ApiQuery)({
        name: 'userName',
        type: 'string',
        description: 'Name of user to filter',
        required: false,
    }),
    (0, swagger_1.ApiQuery)({
        name: 'email',
        type: 'string',
        description: 'Name of email to filter',
        required: false,
    }),
    (0, swagger_1.ApiQuery)({
        name: 'role',
        type: 'string',
        description: 'Name of role to filter',
        required: false,
    }),
    (0, swagger_1.ApiQuery)({
        name: 'active',
        type: 'boolean',
        description: 'Indicator of active or desactive users',
        required: false,
    }),
    (0, swagger_1.ApiQuery)({
        name: 'company',
        type: 'string',
        description: 'Name of company to filter',
        required: false,
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Get all users or filter by query params. AuthGuard Required',
    }),
    __param(0, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "fetchAllUsers", null);
__decorate([
    (0, common_1.Post)(),
    (0, swagger_1.ApiBody)({
        description: 'Creating a new user',
        examples: {
            example: {
                value: {
                    userName: "userTest",
                    password: "123456789Abc!",
                    email: "usertest@gmail.com",
                    role: {
                        name: "OPERATOR"
                    },
                    active: true,
                }
            }
        }
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Creates a new user. AuthGuard Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [user_dto_1.UserDto]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "createUser", null);
__decorate([
    (0, common_1.Post)('noAuth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Creates a new user. AuthGuard Not Required',
    }),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [user_dto_1.UserDto]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "createUserNoAuth", null);
__decorate([
    (0, common_1.Put)('/:userName'),
    (0, swagger_1.ApiParam)({
        name: 'userName',
        type: 'string',
        description: 'Name of user to update'
    }),
    (0, swagger_1.ApiBody)({
        description: 'Updating a existing user',
        examples: {
            example: {
                value: {
                    userName: "userTest",
                    password: "!Abc123456789",
                    email: "newUserTestEmail@gmail.com",
                    role: {
                        name: "ADMIN"
                    },
                    active: true,
                }
            }
        }
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Updates data from a user. AuthGuard Required',
    }),
    __param(0, (0, common_1.Param)('userName')),
    __param(1, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, edit_user_dto_1.EditUserDto]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "updateUser", null);
__decorate([
    (0, common_1.Delete)('/:userName'),
    (0, swagger_1.ApiParam)({
        name: 'userName',
        type: 'string',
        description: 'Name of user to remove'
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Deletes a user. AuthGuard Required',
    }),
    __param(0, (0, common_1.Param)('userName')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "deleteUser", null);
__decorate([
    (0, common_1.Put)('activate/:userName'),
    (0, swagger_1.ApiParam)({
        name: 'userName',
        type: 'string',
        description: 'Name of user to active or desactivate'
    }),
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)()),
    (0, swagger_1.ApiBearerAuth)('JWT-auth'),
    (0, swagger_1.ApiOperation)({
        summary: 'Update active/desactive user. AuthGuard Required',
    }),
    __param(0, (0, common_1.Param)('userName')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "activateUser", null);
__decorate([
    (0, common_1.Put)('pwdRecovery/:email'),
    (0, swagger_1.ApiParam)({
        name: 'email',
        type: 'string',
        description: 'Name of email to make a recovery password token'
    }),
    (0, swagger_1.ApiOperation)({
        summary: 'Password recovery for user. AuthGuard Not Required',
    }),
    __param(0, (0, common_1.Param)('email')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "pwdRecovery", null);
__decorate([
    (0, common_1.Put)('updatePassword/:userName'),
    (0, swagger_1.ApiParam)({
        name: 'userName',
        type: 'string',
        description: 'Name of user to update current password'
    }),
    (0, swagger_1.ApiBody)({
        description: 'Update password from a user',
        examples: {
            example: {
                value: {
                    userName: "userTest",
                    password: "!Abc123456789",
                    email: "newUserTestEmail@gmail.com",
                    role: {
                        name: "ADMIN"
                    },
                    active: true,
                }
            }
        }
    }),
    (0, swagger_1.ApiOperation)({
        summary: 'Updates password for a user. AuthGuard Not Required',
    }),
    __param(0, (0, common_1.Param)('userName')),
    __param(1, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, edit_user_dto_1.EditUserDto]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "updateUserPassword", null);
__decorate([
    (0, common_1.Get)('byPwdRecovery/:pwdRecoveryToken'),
    (0, swagger_1.ApiParam)({
        name: 'pwdRecoveryToken',
        type: 'string',
        description: 'Password recovery token of user to get user by it'
    }),
    (0, swagger_1.ApiOperation)({
        summary: 'Get user by email. AuthGuard Not Required',
    }),
    __param(0, (0, common_1.Param)('pwdRecoveryToken')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], UsersController.prototype, "fetchUserByPwdRecovery", null);
UsersController = __decorate([
    (0, common_1.Controller)(`api/v1/users`),
    (0, swagger_1.ApiTags)('users'),
    __metadata("design:paramtypes", [users_service_1.UsersService])
], UsersController);
exports.UsersController = UsersController;
//# sourceMappingURL=users.controller.js.map