import { PaginationDto } from './../pagination/pagination.dto';
import { PaginationService } from './../pagination/pagination.service';
import { Model } from 'mongoose';
import { IUser } from '../models-mongo/user.model';
import { RolesService } from '../roles/roles.service';
import { WebsocketGateway } from '../websocket/websocket.gateway';
import { EditUserDto } from './dto/edit-user.dto';
import { UserDto } from './dto/user.dto';
import { CompaniesService } from '../companies/companies.service';
export declare class UsersService {
    private readonly paginationService;
    private readonly roleService;
    private companiesService;
    private readonly websocketService;
    private UserModel;
    constructor(paginationService: PaginationService, roleService: RolesService, companiesService: CompaniesService, websocketService: WebsocketGateway, UserModel: Model<IUser>);
    fetchAllUsers(query: any): Promise<IUser[] | PaginationDto>;
    createUser(newUser: UserDto): Promise<IUser>;
    updateUser(userName: string, newUser: EditUserDto): Promise<IUser>;
    deleteUser(userName: string): Promise<IUser>;
    activateUser(userName: string): Promise<IUser>;
    pwdRecovery(email: string): Promise<IUser>;
    updateUserPassword(userName: string, newUser: EditUserDto): Promise<IUser>;
    fetchUserByPwdRecovery(pwdRecoveryToken: string): Promise<IUser>;
    findUser(userName: string): Promise<IUser>;
    fetchUser(userName: string): Promise<IUser>;
    findUserByEmail(email: string): Promise<IUser>;
    roleHasUsers(name: string): Promise<boolean>;
    private encryptPassword;
    private generatePasswordRecoveryToken;
    fetchUserData(userName: string): Promise<IUser & import("mongoose").Document<any, any, IUser>>;
    notifyWebsockets(): Promise<void>;
}
