import { DynamicModule, ModuleMetadata, Type } from '@nestjs/common';
import { WebsocketConfig } from './websocket-config';
interface WebSocketsConfigFactory {
    createWebSocketsConfig(): Promise<WebsocketConfig> | WebsocketConfig;
}
export interface WebSocketsAsyncConfig extends Pick<ModuleMetadata, 'imports'> {
    inject?: any[];
    useExisting?: Type<WebSocketsConfigFactory>;
    useClass?: Type<WebSocketsConfigFactory>;
    useFactory?: (...args: any[]) => Promise<WebsocketConfig> | WebsocketConfig;
}
export declare class WebsocketModule {
    static register(options: WebsocketConfig): DynamicModule;
    static registerAsync(options: WebSocketsAsyncConfig): DynamicModule;
    private static createConfigProviders;
}
export {};
